Program CutofFS

!   Solving Consumer Bankruptcy with Fresh Start		!
!	Note: No shocks in the last period					!
!	No expense shock in the first period				!
!		To change that:									!
!			Fix calculation of EV						!
!			and 1st period in simulations				!
!	Bankruptcy rulled out in the last period			!
!		- computational convenience						!
!	Multiplicative transitory income shocks				!
!		on top of Markovian income process				!
!	Expense shocks proportional to						!
!		Markov component of income process				!
!	Bankruptcy is rulled out immediately following		!
!		a previous bankruptcies.						!
!		Default option is introduced for that period	!


!	Note: Defaulters (after bankruptcy) are not counted as defaulters.	!
!			Their debts do not appear in any of the aggregates.			!

!	Note: Filers of age (lifespan-2) who Default at age (lifespan-1),	!
!			are the only ones allowed to file in last peroid.			!

!	Note: Autonomous consumption is included in measured consumption.	!

!	Warning: Numerical precision during the aggregation may be problematic.		!

!	Implicit Integer(i-k,s), Real(8)(c,p-r,u-w)
Implicit none

Interface
	Real(8) Function Utility(c,cig)
	real(8) c, cig
	end function

	Function Sort(unsorted) !Result (sorted)
	Real, Dimension (:) :: unsorted
	Real, Dimension (size(unsorted)) :: Sort, sorted
	end function

	Recursive Function R_valmed (XDONT) Result (res_med)
	Real, Dimension (:), Intent (In) :: XDONT
	Real :: res_med
	Real, Parameter :: XHUGE = HUGE (XDONT)
	Real, Dimension (SIZE(XDONT)+6) :: XWRKT
	Real :: XWRK, XWRK1, XMED7
	Integer, Dimension ((SIZE(XDONT)+6)/7) :: ISTRT, IENDT, IMEDT
	Integer :: NDON, NTRI, NMED, NORD, NEQU, NLEQ, IMED, IDON, IDON1
	Integer :: IDEB, IWRK, IDCR, ICRS, ICRS1, ICRS2, IMED1
	end function
end interface


Integer age, avtrans, bin, bmax, count, gridmax, groups, i, id, ii, iii, increason, j
Integer k, kk, kprime, ks, lifespan, limit, limitn, loss
Integer Monte, Monte1, Pop, s, sh, shocks, smax, ss, st, sstop, states, trans, transreason
Integer bins(17,5,3), BR(17,5,3,20001), BRafter(17,5,3,5), DebtRolled(17,5,3,5)
Integer history(17), kpos(17), PopB(20), sdummy(1), shockhis(17), stigma(17), transhis(17)

Real(8) asum, asum2, aut, autlast, avborint, avdoib, avdoid, avlncon, avlninc
Real(8) baddebt, balance, bankruptcy, betanorm, betalast, borrowers, borrowante
Real(8) bprime, burn, burn2, cbar, cigma, costfile, coststig1, coststig2, conalt
Real(8) debt, debtadd, defaults, disposable, EV, garn, gridfine, intinc, maxborint, maxintgen1, net
Real(8) output, outdef, qq, rb, rmax, rroll, rs, saving
Real(8) take, varlncon, varlninc, Vcont, wage, wannasave, wss								!, Utility
Real(8) A(3), avdebincB(20), avinttotal(100), avlnconage(17), avlnincage(17), bankrtotal(100)
Real(8) beta(17), borpostB(20), borrow(17,5,3,5), borrowB(20), borrowbyage(17)
Real(8) borrowerposttotal(100), borrowerantetotal(100), BRbyreason(5,2,2)
Real(8) cand(20001), ccand(20001), Con(17,5,3,20001), Con1(17,5,3,5), ConB(17,5,3), ConD(17,5,3,5), cons(17), cutoff(20)
Real(8) debincB(20), debtB(20), debtbyage(17), debtincbortotal(100), debtincdeftotal(100)			!, debtdist(20,5,5,5), debtincdef(17,5,5,5)
Real(8) debtpostB(20), debttotal(100), defaulttotal(100)											!, income(3000000), earnings(3000000), wealth(3000000)
Real(8) ES(17), expenconst(5), expenprop(5), expense(5,5), filingsB(20), fracborrow(17,5,3,5), hbar(17), inco(17)
Real(8) newbankruptcy(17), outputB(20), phi(5), prob(5,5), prob0(5), probt(3), probs(5)
Real(8) q(17,5,20001), qtemp(5), savebyage(17), savers(100), savetotal(100)
Real(8) V(17,5,3,20001), V0(17,5), V0alt(17,5), Vafter(17,5,3,5), Vaftalt(17,5,3,5), varlnconage(17), varlnincage(17)
Real(8) VbarFS(17,5,3), Vbaralt(17,5,3), Vdef(17,5,3,5), Vdefalt(17,5,3,5), Vprime(17,5,20001), writeoff(100)

Real temp(129038)				!, tempa(1000000), tempb(1000000), temp1(524288), temp2(524288)					!, Sort(1024)
Real, Dimension (129038) :: income, earnings, wealth			!, Target
!Real, Dimension (:), Pointer :: point

Logical defafter, run0, ystig1, ystig2, ystig3
limit=20001
limitn = 129038		!	117649		823543		129038


!iii = 86563476		!	Initial seed for RNG	!
!do i=1,limitn
!	income(i)=ran(iii)
!end do

!tempa=income(1:100000)
!print *, tempa
!tempb=Sort(tempa)
!print *,'Median is between ', tempb(50000), ' and ', tempb(50001)
!pause



!print *,'Median is ', R_valmed(tempa)
!pause
!temp=income(1:limitn)
!print *,'Median is ', R_valmed(income)
!pause
!tempa=income(1:1000000)
!print *,'Median is ', R_valmed(income)
!pause




do i=1,limit
	cand(i)=-1.d96
end do
!debtdist=0.0
debtbyage=0.0
borrow=0.0
fracborrow=0.0
borrowbyage=0.0
savebyage=0.0
!do i=1,10
!	do ii=1,5
!		do iii=1,5
!			avint(i,ii,iii)=0.0
!			maxint(i,ii,iii)=1.0
!			debtdist(i,ii,iii)=0.0
!			newdef(i,ii,iii)=0.0
!			dist(i,ii,iii)=0.0
!			consu(i,ii,iii)=0.0
!			incom(i,ii,iii)=0.0
!			debtincome(i,ii,iii)=0.0
!			debtincdef(i,ii,iii)=0.0
!			debtincbor(i,ii,iii)=0.0
!			borrow(i,ii,iii)=0.0
!		end do
!	end do
!end do

!   Parameters  !
open (8,file='inputCut.txt')
read (8,*) id
read (8,*) lifespan, states, trans, shocks, groups, gridfine
read (8,*) cigma, aut, autlast, cbar, rs, rb, rmax, rroll, garn, burn, burn2, costfile, coststig1, coststig2
	!		Elasticity, Autonomous consumption, Autonomous in the last period, Exemption,
	!...	Risk-free savings rate, Risk-free borrowing rate, Max borrowing interest rate, Roll-over rate
	!...	Fraction of labour income garnished, Fraction of consumption burnt for 2 periods
	!...	Cost of filing, Additive utility stigmas for 2 periods					!
read (8,*) (hbar(i),i=1,lifespan)				!	Labor endowments				!
read (8,*) betanorm, betalast					!	Beta in normal periods, beta for last period	!
read (8,*) (ES(i),i=1,lifespan)					!	Equivalence scales				!
read (8,*) (cutoff(i),i=1,(groups-1))			!	Income cutoffs for reporting	!
read (8,*) (phi(i),i=1,states)					!	Persistent income draws			!
read (8,*) (prob0(i),i=1,states)				!	Initial probabilities			!
read (8,*) (A(i),i=1,trans)						!	Transitory income draws			!
read (8,*) (probt(i),i=1,trans)					!	Transitory probabilities		!
read (8,*) (expenconst(i),i=1,shocks)			!	Expense Shocks - Intercepts		!
read (8,*) (expenprop(i),i=1,shocks)			!	Expense Shocks - Slopes			!
read (8,*) (probs(i),i=1,shocks)				!	Probabilities of shocks			!
read (8,*) ((prob(i,j),j=1,states),i=1,states)	!	Transitional probabilities		!
close (8)

! gridfine=500.0

cutoff(groups)=maxval(hbar)*maxval(phi)*maxval(A)+1.0
do age=1,lifespan-1
	do s=1,states
		do st=1,trans
			wage=hbar(age)*phi(s)*A(st)
			i=1
			do while (wage>cutoff(i))
				i=i+1
			end do
			bins(age,s,st)=i
		end do
	end do
end do
do age=1,lifespan-2
	beta(age) = betanorm*(ES(age)/ES(age+1))**(1-cigma)
end do
age=lifespan-1
beta(age) = betalast*(ES(age)/ES(age+1))**(1-cigma)
do i=1,states
	do ii=1,shocks
		expense(i,ii)=expenconst(ii)+expenprop(ii)*phi(i)
	end do
	expense(i,shocks+1)=0.0
end do
probs(shocks+1)=1.0
do sh=1,shocks
	probs(shocks+1)=probs(shocks+1)-probs(sh)
end do
avtrans=nint(trans/2.0)

!	Figuring out a grid that fits	!
sstop=0
do while (sstop.eq.0)
	smax=nint((maxval(phi)*maxval(A)*maxval(hbar)*lifespan/2)*gridfine)+1
	bmax=smax+nint(maxval(expense)*lifespan*gridfine/2)+1
	gridmax=smax+bmax+1

	print *,'bmax=',bmax
	print *,'gridmax=',gridmax
	if (gridmax>limit) then
		print *,'Grid is too large for arrays to handle. Adjusting grid.'
!		pause
		gridfine=nint(gridfine/2.0)
	else
		sstop=1
	end if
end do


print *,'Pr(5,4)=',prob(5,4)



!	V(age,s,A,i) = max [Utility + beta * E[max(V(age+1,s',A',i'),Vbar(age+1,s',A'))]]	= Value of Repaying
!	Vbar(age,s,A) = Utility(burn,garn) + beta * V0(age,s)								= Value of Bankruptcy
!	V0(age,s) = E[max(Vafter(age+1,s',A',shock'),Vdef(age+1,s',A',shock'))]				= Continuation Value during Bankruptcy
!	V0alt(age,s) = E[max(Vaftalt(age+1,s',A',shock'),Vdefalt(age+1,s',A',shock'))]		= Continuation Value during Bankruptcy while saving min possible
!	Vafter(age,s,A,shock) = max[Utility(burn2) + beta * Vprime(age,s,i')]				= Value of Repaying after Bankruptcy
!	Vdef(age,s,A,shock) = Utility(burn,garn) + beta * Vprime(age,s',i'(shock))			= Value of Default after Bankruptcy
!	Vprime(age,s,i) = E[max(V(age+1,s',A',i),Vbar(age+1,s',A'))]]						= Continuation Value next period


!   Last Generation !
age=lifespan
do s=1,states
    wage=phi(s)*hbar(age)
	do i=1,gridmax
		net=(i-1-bmax)/gridfine
        if ((wage+net)<0.0) then
	        V(age,s,1:trans,i)=-1.d96
		else
			Con(age,s,1:trans,i)=wage+net
			V(age,s,1:trans,i)=Utility(autlast+wage+net,cigma)
	    end if
	end do
end do
do s=1,states
	wage=phi(s)*hbar(age)
	ConB(age,s,1:trans)=(wage-max((wage-cbar)*garn,0.0)-costfile)*(1.0-burn)
	if (ConB(age,s,1)<0.0) then
		print *,'Filing costs too high for old guys. State = ',s
		pause
		goto 777
	end if
	Con1(age,s,1:trans,1:5)=wage*(1.0-burn2)
	V0(age-1,s)=Utility(autlast+wage*(1.0-burn2),cigma)-coststig2
    V0alt(age-1,s)=Utility(autlast+(wage+1.0/gridfine)*(1.0-burn2),cigma)-coststig2
	!	Note:	There is no possibility of default here:					!
	!			If they went bankrupt last period, their balance is 0		!
	!				and they do not get expense shocks.						!
end do

do s=1,states
	print *,V(age,s,1:trans,bmax+1)
end do
!pause

!   Other Generations   !
do age=(lifespan-1),1,-1
    do s=1,states

		!   Pricing the debt    !
		do k=1,gridmax
            balance=(k-1-bmax)/gridfine
			if (age<lifespan-1) then
				Vcont=0.0
				qq=0.0
				do ss=1,states
					do st=1,trans
						wss=phi(ss)*A(st)*hbar(age+1)
						do sh=1,shocks+1
							loss=nint(expense(ss,sh)*gridfine)
							ks=max(k-loss,1)
							if (V(age+1,ss,st,ks)<VbarFS(age+1,ss,st)) then
								Vcont=Vcont+prob(s,ss)*probt(st)*probs(sh)*VbarFS(age+1,ss,st)
								if (balance<0.0) then
									qq=qq+max((wss-cbar)*garn,0.0)*probs(sh)*prob(s,ss)*probt(st)/(expense(ss,sh)-balance)
								else
									qq=qq+prob(s,ss)*probs(sh)*probt(st)
								end if
							else
								Vcont=Vcont+prob(s,ss)*probt(st)*probs(sh)*V(age+1,ss,st,ks)
								qq=qq+prob(s,ss)*probt(st)*probs(sh)
							end if
						end do
		            end do
				end do
			else
				wss=phi(s)*hbar(age+1)
				if (wss+balance<0.0) then
					Vcont=-1.d96
					qq=0.0
				else
					Vcont=V(age+1,s,1,k)
					qq=1.0
				end if
			end if

			if (balance<0.0) then
				if (qq<(1.0+rb)/(1.0+rmax)) then		!	Interest rate ceiling binds	!
					q(age,s,k)=0.0
				else
					q(age,s,k)=qq/(1.0+rb)
				end if
			else
				q(age,s,k)=1.0/(1.0+rs)
			end if
			Vprime(age,s,k)=Vcont
		end do


		print *,'State',s


		do st=1,trans
		    wage=phi(s)*A(st)*hbar(age)

!			print *,'Transitory',st

	        do i=1,gridmax
		        net=(i-1-bmax)/gridfine
			    do k=1,gridmax
				    balance=(k-1-bmax)/gridfine
					disposable=net-q(age,s,k)*balance
	                if ((wage+disposable)<=0.0) then
		                cand(k)=-1.d96
			        else
						ccand(k)=wage+disposable
						cand(k)=Utility(aut+wage+disposable,cigma)
	                end if
		            cand(k)=cand(k)+beta(age)*Vprime(age,s,k)
			    end do

	            !   Maximize    !
		        V(age,s,st,i)=maxval(cand)
				sdummy=maxloc(cand)
				BR(age,s,st,i)=sdummy(1)
				Con(age,s,st,i)=ccand(sdummy(1))
	        end do


			if (age>1) then
				do sh=1,shocks+1
					net=-expense(s,sh)

					!	Value of Repaying after Bankruptcy	!
		            do k=1,gridmax
			            balance=(k-1-bmax)/gridfine
				        disposable=net-q(age,s,k)*balance
					    if ((wage+disposable)<=0.0) then
						    cand(k)=-1.d96
		                else
							ccand(k)=(wage+disposable)*(1-burn2)
							cand(k)=Utility(aut+(wage+disposable)*(1.0-burn2),cigma)
					    end if
						cand(k)=cand(k)+beta(age)*Vprime(age,s,k)
					end do

		            !   Maximize    !
			        Vafter(age,s,st,sh)=maxval(cand)-coststig2
					sdummy=maxloc(cand)
					BRafter(age,s,st,sh)=sdummy(1)
					Con1(age,s,st,sh)=ccand(sdummy(1))


					!	Value of Repaying after Bankruptcy with Saving 1	!
		            do k=1,gridmax
			            balance=(k-1-bmax)/gridfine
				        disposable=net+1.0/gridfine - q(age,s,k)*balance
					    if ((wage+disposable)<=0.0) then
						    cand(k)=-1.d96
		                else
							ccand(k)=(wage+disposable)*(1-burn2)
							cand(k)=Utility(aut+(wage+disposable)*(1.0-burn2),cigma)
					    end if
						cand(k)=cand(k)+beta(age)*Vprime(age,s,k)
					end do
		            !   Maximize    !
			        Vaftalt(age,s,st,sh)=maxval(cand)-coststig2


					!	Value of Default after Bankruptcy	!
					take=max((wage-cbar)*garn,0.0)
					bprime=min((net+take)*(1+rroll),0.0)
					DebtRolled(age,s,st,sh)=bmax+1+nint(bprime*gridfine)
					ConD(age,s,st,sh)=(wage-take)*(1.0-burn)
					if (age<lifespan-1) then
						Vdef(age,s,st,sh)=Utility(aut+ConD(age,s,st,sh),cigma)-coststig1+beta(age)*Vprime(age,s,DebtRolled(age,s,st,sh))
					else
						Vdef(age,s,st,sh)=Utility(aut+ConD(age,s,st,sh),cigma)-coststig1+beta(age)*(Utility(autlast+ConB(age+1,s,1),cigma)-coststig1)
					end if

					!	Value of Default after Bankruptcy with Saving 1	!
					take=max((wage-cbar)*garn,0.0)
					bprime=min((net+1.0/gridfine+take)*(1+rroll),0.0)
					conalt=(wage-take)*(1.0-burn)
					if (age<lifespan-1) then
						Vdefalt(age,s,st,sh)=Utility(aut+conalt,cigma)-coststig1+beta(age)*Vprime(age,s,bmax+1+nint(bprime*gridfine))
					else
						Vdefalt(age,s,st,sh)=Utility(aut+conalt,cigma)-coststig1+beta(age)*(Utility(autlast+ConB(age+1,s,1),cigma)-coststig1)
					end if

			    end do
			end if


	        !   Value of Bankruptcy   !
			ConB(age,s,st)=(wage-max((wage-cbar)*garn,0.0)-costfile)*(1.0-burn)
			if (ConB(age,s,st)<0.0) then
				print *,'Filing costs too high. Age, persist, trans = ',age,s,st
				pause
				goto 777
			end if
			VbarFS(age,s,st)=Utility(aut+ConB(age,s,st),cigma)-coststig1+beta(age)*V0(age,s)

	        !   Value of Bankruptcy with Saving 1	!
			conalt=(wage-max((wage-cbar)*garn,0.0)-costfile-1.0/(gridfine*(1.0+rs)))*(1.0-burn)
			if (conalt<0.0) then
				print *,'Filing costs almost too high. Age, persist, trans = ',age,s,st
				pause
				goto 777
			end if
			Vbaralt(age,s,st)=Utility(aut+conalt,cigma)-coststig1+beta(age)*V0alt(age,s)
	    end do
	end do

    if (age>1) then
        do s=1,states
            asum=0.0
			asum2=0.0
            do ss=1,states
				do st=1,trans
					do sh=1,shocks+1
						asum=asum+prob(s,ss)*probt(st)*probs(sh)*max(Vafter(age,ss,st,sh),Vdef(age,ss,st,sh))
						asum2=asum2+prob(s,ss)*probt(st)*probs(sh)*max(Vaftalt(age,ss,st,sh),Vdefalt(age,ss,st,sh))
					end do
		        end do
			end do
            V0(age-1,s)=asum
            V0alt(age-1,s)=asum2
        end do
    end if


	print *,'Age=',age
	do s=1,states
		print *,V(age,s,1:trans,bmax+1)
	end do
	do s=1,states
		print *,BR(age,s,1:trans,bmax+1)
	end do
    !pause
end do

EV=0.0
do s=1,states
	do st=1,trans

!		do sh=1,shocks+1
!			loss=nint(expense(s,sh)*gridfine)
!			ks=bmax+1-loss
!			EV=EV+prob0(s)*probt(st)*probs(sh)*max(V(1,s,st,ks),VbarFS(1,s,st))
!		end do

	    EV=EV+prob0(s)*probt(st)*V(1,s,st,bmax+1)
	end do
end	do
print *,'EV=',EV

999 format (F8.4,5F8.5)
open (21,file='qFS.txt')
write (21,*) 'Input ID#',id
write (21,*) 'EV=',EV
write (21,*) 'Balance','Prices'
do i=1,(bmax+3)
	net=(i-1-bmax)/gridfine
	write (21,999) net,q(1,1:states,i)
end do
close (21)

998 format (F8.4,15F8.5)
open (22,file='qFSage.txt')
write (22,*) 'Input ID#',id
write (22,*) 'EV=',EV
write (22,*) 'Prices_for_individuals_with_persistent_state_3_by_age'
write (22,*) 'Balance ','Prices_by_age'
do i=1,(bmax+3)
	net=(i-1-bmax)/gridfine
	write (22,998) net,q(1:(lifespan-1),3,i)
end do
close (22)



!			Simulations								!
!	Pop = Population per generation in a simulation	!
!	Monte = Number of simulations					!

Pop = 100000
Monte1 = 15
Monte = 30
iii = 8657658		!	Initial seed for RNG	!

count=0
do age=1,lifespan
	newbankruptcy(age)=0.0
	cons(age)=0.0
	avlnconage(age)=0.0
	avlnincage(age)=0.0
end do
BRbyreason(1:5,1:2,1:2)=0.0
outdef=0.0
output=0.0

PopB=0
outputB=0.0
debtB=0.0
borrowB=0.0
borpostB=0.0
debtpostB=0.0
avdebincB=0.0
filingsB=0.0

do j=1,Monte1
	debt=0.0
	saving=0.0
	avborint=0.0
	borrowante=0.0
	bankruptcy=0.0
	wannasave=0.0
	defaults=0.0
	borrowers=0.0
	avdoib=0.0
	avdoid=0.0
	baddebt=0.0

	do i=1,Pop
		wss=ran(iii)
		!	Assigning Markov productivity	!
		sstop=0
		asum=0.0
		s=1
		do while (sstop.eq.0)
			if (wss < asum + prob0(s)) then
				history(1)=s
				sstop=1
				if (s>states) then
					print *,'Run #',j,' Markov =',s,' Random =',wss
					history(1)=states
				end if
			else
				asum = asum + prob0(s)
				s=s+1
			end if
		end do

		wss=ran(iii)
		!	Assigning transitory productivity	!
		sstop=0
		asum=0.0
		st=1
		do while (sstop.eq.0)
			if (wss < asum + probt(st)) then
				transhis(1)=st
				sstop=1
				if (st>trans) then
					print *,'Run #',j,' Transitory =',st,' Random =',wss
					transhis(1)=trans
				end if
			else
				asum = asum + probt(st)
				st=st+1
			end if
		end do

!		wss=ran(iii)
!		!	Assigning expense shock	!
!		sstop=0
!		asum=0.0
!		sh=1
!		do while (sstop.eq.0)
!			if (wss < asum + probs(sh)) then
!				shockhis(1)=sh
!				sstop=1
!				if (sh>shocks+1) then
!					print *,'Run #',j,' Person #',i,' Age =',age,' Expense =',sh,' Random =',wss
!					shockhis(1)=shocks+1
!				end if
!			else
!				asum = asum + probs(sh)
!				sh=sh+1
!			end if
!		end do
!		loss=nint(expense(history(1),shockhis(1))*gridfine)
!		kpos(1)=bmax+1-loss

		shockhis(1)=shocks+1
		kpos(1)=bmax+1

		wage=phi(history(1))*A(transhis(1))*hbar(1)
		bin=bins(1,history(1),transhis(1))
		PopB(bin)=PopB(bin)+1
		outputB(bin)=outputB(bin)+wage

		if (count<limitn) then
			count=count+1
			income(count)=wage
			earnings(count)=wage
			wealth(count)=0.0
		endif

		if (wage>0.0) then
			output=output+wage
			avlnincage(1)=avlnincage(1)+log(wage)
		else
			avlnincage(1)=avlnincage(1)-1.0d80
		end if

!		if (V(1,history(1),transhis(1),kpos(1)) < VbarFS(1,history(1),transhis(1))) then
!			bankruptcy=bankruptcy+1.0
!			newbankruptcy(1)=newbankruptcy(1)+1.0
!			stigma(1)=1
!			cons(1)=cons(1)+ConB(1,history(1),transhis(1))+aut
!			avlnconage(1)=avlnconage(1)+log(ConB(1,history(1),transhis(1))+aut)
!			avdoid=avdoid+((bmax+1-kpos(1))/gridfine)/wage
!			baddebt=baddebt+(bmax+1-kpos(1))/gridfine
!			outdef=outdef+wage
!			increason=1		!	No income shock	!
!			transreason=1		!	No income shock	!
!			BRbyreason(shockhis(age),increason,transreason)=BRbyreason(shockhis(age),increason,transreason)+1.0
!			if (Vbaralt(1,history(1),transhis(1))>VbarFS(1,history(1),transhis(1))) then
!				wannasave=wannasave+1.0
!			endif
!			kprime=bmax+1
!		else
			stigma(1)=0
			kprime=BR(1,history(1),transhis(1),kpos(1))
			cons(1)=cons(1)+Con(1,history(1),transhis(1),kpos(1))+aut
			avlnconage(1)=avlnconage(1)+log(Con(1,history(1),transhis(1),kpos(1))+aut)
!		end if

		if (kprime<bmax+1) then
			debtadd=-(q(1,history(1),kprime)*(kprime-1-bmax)/gridfine)
			if (debtadd<0) then
				print *,'Debt<0'
				print *,'q=',q(1,history(1),kprime)
				!pause
			else
				debt=debt+debtadd
				debtB(bin)=debtB(bin)+debtadd
				borrowB(bin)=borrowB(bin)+1.0
				debtbyage(1)=debtbyage(1)+debtadd
				borrowante=borrowante+1.0
				borrow(1,history(1),transhis(1),shockhis(1))=borrow(1,history(1),transhis(1),shockhis(1)) + 1.0
				avborint=avborint-(1-q(1,history(1),kprime))*(kprime-bmax-1)/gridfine
			end if
		else
			debtadd=((kprime-1-bmax)/gridfine)/(1+rs)
			saving=saving+debtadd
			savebyage(1)=savebyage(1)+debtadd
		end if


		do age=2,lifespan-1
			wss=ran(iii)
			!	Assigning Markov productivity	!
			sstop=0
			asum=0.0
			s=1
			do while (sstop.eq.0)
				if (wss < asum + prob(history(age-1),s)) then
					history(age)=s
					sstop=1
					if (s>states) then
						print *,'Run #',j,' Person #',i,' Age =',age,' Markov =',s,' Random =',wss
						history(age)=states
					end if
				else
					asum = asum + prob(history(age-1),s)
					s=s+1
				end if
			end do

			wss=ran(iii)
			!	Assigning transitory productivity	!
			sstop=0
			asum=0.0
			st=1
			do while (sstop.eq.0)
				if (wss < asum + probt(st)) then
					transhis(age)=st
					sstop=1
					if (st>trans) then
						print *,'Run #',j,' Person #',i,' Age =',age,' Transitory =',st,' Random =',wss
						transhis(age)=trans
					end if
				else
					asum = asum + probt(st)
					st=st+1
				end if
			end do

			wss=ran(iii)
			!	Assigning expense shock	!
			sstop=0
			asum=0.0
			sh=1
			do while (sstop.eq.0)
				if (wss < asum + probs(sh)) then
					shockhis(age)=sh
					sstop=1
					if (sh>shocks+1) then
						print *,'Run #',j,' Person #',i,' Age =',age,' Expense =',sh,' Random =',wss
						shockhis(age)=shocks+1
					end if
				else
					asum = asum + probs(sh)
					sh=sh+1
				end if
			end do

			wage=phi(history(age))*A(transhis(age))*hbar(age)
			bin=bins(age,history(age),transhis(age))
			PopB(bin)=PopB(bin)+1
			outputB(bin)=outputB(bin)+wage

			ystig1=(stigma(age-1).eq.1)
			ystig2=(stigma(age-1).eq.2)
			ystig3=(stigma(age-1).eq.3)
			if (ystig1) then
				kpos(age)=bmax+1
			else if (ystig2) then
				kpos(age)=BRafter(age-1,history(age-1),transhis(age-1),shockhis(age-1))
			else if (ystig3) then
				kpos(age)=DebtRolled(age-1,history(age-1),transhis(age-1),shockhis(age-1))
			else
				kpos(age)=BR(age-1,history(age-1),transhis(age-1),kpos(age-1))
			end if
			loss=nint(expense(history(age),shockhis(age))*gridfine)
			kpos(age)=max(kpos(age)-loss,1)
			if (kpos(age) < bmax+1) then
				borrowers=borrowers+1.0
				avdoib=avdoib+((bmax+1-kpos(age))/gridfine)/wage
				borpostB(bin)=borpostB(bin)+1.0
				avdebincB(bin)=avdebincB(bin)+((bmax+1-kpos(age))/gridfine)/wage
				debtpostB(bin)=debtpostB(bin)+(bmax+1-kpos(age))/gridfine
				intinc=0.0
			else
				intinc=((kpos(age)-bmax-1)/gridfine)*rs/(1+rs)
			end if

			if (count<limitn) then
				count=count+1
				income(count)=wage+intinc
				earnings(count)=wage
				wealth(count)=(kpos(age)-bmax-1)/gridfine
			endif

			if (wage>0.0) then
				output=output+wage
				avlnincage(age)=avlnincage(age)+log(wage)
			else
				avlnincage(age)=avlnincage(age)-1.0d80
			end if

			run0=(V(age,history(age),transhis(age),kpos(age))<VbarFS(age,history(age),transhis(age)))
			defafter=(Vafter(age,history(age),transhis(age),shockhis(age))<Vdef(age,history(age),transhis(age),shockhis(age)))


			if (ystig1) then
				if (defafter) then
					defaults=defaults+1.0
					stigma(age)=3
					kprime=bmax+1		!	Rolled-over debts do not get counted
!					kprime=DebtRolled(age,history(age),transhis(age),shockhis(age))
					cons(age)=cons(age)+ConD(age,history(age),transhis(age),shockhis(age))+aut
					avlnconage(age)=avlnconage(age)+log(ConD(age,history(age),transhis(age),shockhis(age))+aut)
				else
					stigma(age)=2
					kprime=BRafter(age,history(age),transhis(age),shockhis(age))
					cons(age)=cons(age)+Con1(age,history(age),transhis(age),shockhis(age))+aut
					avlnconage(age)=avlnconage(age)+log(Con1(age,history(age),transhis(age),shockhis(age))+aut)
				end if
			elseif (run0) then
				bankruptcy=bankruptcy+1.0
				newbankruptcy(age)=newbankruptcy(age)+1.0
				filingsB(bin)=filingsB(bin)+1.0
				stigma(age)=1
				cons(age)=cons(age)+ConB(age,history(age),transhis(age))+aut
				avlnconage(age)=avlnconage(age)+log(ConB(age,history(age),transhis(age))+aut)
				avdoid=avdoid+((bmax+1-kpos(age))/gridfine)/wage
				baddebt=baddebt+(bmax+1-kpos(age))/gridfine
				outdef=outdef+wage
				if (history(age)<history(age-1)) then
					increason=2		!	Persistent income shock	!
				else
					increason=1		!	No income shock	!
				endif
				if (transhis(age)<avtrans) then
					transreason=2		!	Transitory income shock	!
				else
					transreason=1		!	No income shock	!
				endif
				if (Vbaralt(age,history(age),transhis(age))>VbarFS(age,history(age),transhis(age))) then
					wannasave=wannasave+1.0
				endif

				BRbyreason(shockhis(age),increason,transreason)=BRbyreason(shockhis(age),increason,transreason)+1.0
				kprime=bmax+1
			else
				stigma(age)=0
				kprime=BR(age,history(age),transhis(age),kpos(age))
				cons(age)=cons(age)+Con(age,history(age),transhis(age),kpos(age))+aut
				avlnconage(age)=avlnconage(age)+log(Con(age,history(age),transhis(age),kpos(age))+aut)
			end if

			if (kprime<bmax+1) then
				debtadd=-(q(age,history(age),kprime)*(kprime-1-bmax)/gridfine)
				if (debtadd<0) then
					print *,'Debt<0'
					do kk=1,age
						print *,history(kk), transhis(kk), shockhis(kk)
					end do
					print *,'q=',q(age,history(age),kprime)
					!pause
				else
					debt=debt+debtadd
					debtB(bin)=debtB(bin)+debtadd
					borrowB(bin)=borrowB(bin)+1.0
					debtbyage(age)=debtbyage(age)+debtadd
!					debtdist(age,history(age),transhis(age),shockhis(age))=debtdist(age,history(age),transhis(age),shockhis(age))+debtadd
					borrowante=borrowante+1.0
					borrow(age,history(age),transhis(age),shockhis(age))=borrow(age,history(age),transhis(age),shockhis(age)) + 1.0
					avborint=avborint-(1-q(age,history(age),kprime))*(kprime-bmax-1)/gridfine
				end if
			else
				debtadd=((kprime-1-bmax)/gridfine)/(1+rs)
				saving=saving+debtadd
				savebyage(age)=savebyage(age)+debtadd
			end if

		end do


		age=lifespan
		history(age)=history(age-1)
		transhis(age)=avtrans
		shockhis(age)=shocks+1

		wage=phi(history(age))*hbar(age)
		ystig1=(stigma(age-1).eq.1)
		ystig2=(stigma(age-1).eq.2)
		ystig3=(stigma(age-1).eq.3)
		if (ystig1) then
			kpos(age)=bmax+1
		else if (ystig2) then
			kpos(age)=BRafter(age-1,history(age-1),transhis(age-1),shockhis(age-1))
		else if (ystig3) then
			kpos(age)=DebtRolled(age-1,history(age-1),transhis(age-1),shockhis(age-1))
		else
			kpos(age)=BR(age-1,history(age-1),transhis(age-1),kpos(age-1))
		end if
		if (kpos(age) < bmax+1) then
			borrowers=borrowers+1.0
			avdoib=avdoib+((bmax+1-kpos(age))/gridfine)/wage
			intinc=0.0
		else
			intinc=((kpos(age)-bmax-1)/gridfine)*rs/(1+rs)
		end if

		if (count<limitn) then
			count=count+1
			income(count)=wage+intinc
			earnings(count)=wage
			wealth(count)=(kpos(age)-bmax-1)/gridfine
		endif

		if (wage>0.0) then
			output=output+wage
			avlnincage(age)=avlnincage(age)+log(wage)
		else
			avlnincage(age)=avlnincage(age)-1.0d80
		end if

		!	Note:	The only bankruptcies here are last periods' defaults		!
		if (ystig3) then
			bankruptcy=bankruptcy+1.0
			newbankruptcy(age)=newbankruptcy(age)+1.0
			cons(age)=cons(age)+ConB(age,history(age),transhis(age))+autlast
			avlnconage(age)=avlnconage(age)+log(ConB(age,history(age),transhis(age))+autlast)
			avdoid=avdoid+((bmax+1-kpos(age))/gridfine)/wage
			baddebt=baddebt+(bmax+1-kpos(age))/gridfine
			outdef=outdef+wage
			increason=1			!	No income shock	!
			transreason=1		!	No income shock	!
			BRbyreason(shockhis(age),increason,transreason)=BRbyreason(shockhis(age),increason,transreason)+1.0
		else if (ystig1) then
			cons(age)=cons(age)+Con1(age,history(age),transhis(age),shockhis(age))+autlast
			avlnconage(age)=avlnconage(age)+log(Con1(age,history(age),transhis(age),shockhis(age))+autlast)
		else
			cons(age)=cons(age)+Con(age,history(age),transhis(age),kpos(age))+autlast
			avlnconage(age)=avlnconage(age)+log(Con(age,history(age),transhis(age),kpos(age))+autlast)
		end if

	end do

	bankrtotal(j)=(bankruptcy/Pop)/lifespan
	defaulttotal(j)=(defaults/Pop)/lifespan
	if (debt>0.0) then
		avinttotal(j)=avborint/debt
		debttotal(j)=(debt/Pop)/lifespan
		borrowerantetotal(j)=(borrowante/Pop)/lifespan
	else
		avinttotal(j)=0.0
		debttotal(j)=0.0
		borrowerantetotal(j)=0.0
	end if
	savetotal(j)=(saving/Pop)/lifespan
	if (borrowers>0.0) then
		borrowerposttotal(j)=(borrowers/Pop)/lifespan
		debtincbortotal(j)=avdoib/borrowers
	else
		borrowerposttotal(j)=0.0
		debtincbortotal(j)=0.0
	end if
	if (bankruptcy>0.0) then
		debtincdeftotal(j)=avdoid/bankruptcy
		writeoff(j)=baddebt/bankruptcy
		savers(j)=wannasave/bankruptcy
	else
		debtincdeftotal(j)=0.0
		writeoff(j)=0.0
		savers(j)=0.0
	end if

end do

avlnconage = (avlnconage/Pop)/Monte1
avlnincage = (avlnincage/Pop)/Monte1
avlncon=0.0
avlninc=0.0
do age=1,lifespan
	avlncon = avlncon + avlnconage(age)
	avlninc = avlninc + avlnincage(age)
end do
avlncon = avlncon/lifespan
avlninc = avlninc/lifespan


varlnconage = 0.0
varlnincage = 0.0


do j=(Monte1+1),Monte
	debt=0.0
	saving=0.0
	avborint=0.0
	borrowante=0.0
	bankruptcy=0.0
	wannasave=0.0
	defaults=0.0
	borrowers=0.0
	avdoib=0.0
	avdoid=0.0
	baddebt=0.0


	do i=1,Pop
		wss=ran(iii)
		!	Assigning Markov productivity	!
		sstop=0
		asum=0.0
		s=1
		do while (sstop.eq.0)
			if (wss < asum + prob0(s)) then
				history(1)=s
				sstop=1
				if (s>states) then
					print *,'Run #',j,' Markov =',s,' Random =',wss
					history(1)=states
				end if
			else
				asum = asum + prob0(s)
				s=s+1
			end if
		end do

		wss=ran(iii)
		!	Assigning transitory productivity	!
		sstop=0
		asum=0.0
		st=1
		do while (sstop.eq.0)
			if (wss < asum + probt(st)) then
				transhis(1)=st
				sstop=1
				if (st>trans) then
					print *,'Run #',j,' Transitory =',st,' Random =',wss
					transhis(1)=trans
				end if
			else
				asum = asum + probt(st)
				st=st+1
			end if
		end do

!		wss=ran(iii)
!		!	Assigning expense shock	!
!		sstop=0
!		asum=0.0
!		sh=1
!		do while (sstop.eq.0)
!			if (wss < asum + probs(sh)) then
!				shockhis(1)=sh
!				sstop=1
!				if (sh>shocks+1) then
!					print *,'Run #',j,' Person #',i,' Age =',age,' Expense =',sh,' Random =',wss
!					shockhis(1)=shocks+1
!				end if
!			else
!				asum = asum + probs(sh)
!				sh=sh+1
!			end if
!		end do
!
!		loss=nint(expense(history(1),shockhis(1))*gridfine)
!		kpos(1)=bmax+1-loss

		shockhis(1)=shocks+1
		kpos(1)=bmax+1

		wage=phi(history(1))*A(transhis(1))*hbar(1)
		bin=bins(1,history(1),transhis(1))
		PopB(bin)=PopB(bin)+1
		outputB(bin)=outputB(bin)+wage

		if (wage>0.0) then
			output=output+wage
			varlnincage(1)=varlnincage(1)+(log(wage)-avlnincage(1))**2
		else
			varlnincage(1)=varlnincage(1)+(-1.0d80-avlnincage(1))**2
		end if

!		if (V(1,history(1),transhis(1),kpos(1)) < VbarFS(1,history(1),transhis(1))) then
!			bankruptcy=bankruptcy+1.0
!			newbankruptcy(1)=newbankruptcy(1)+1.0
!			stigma(1)=1
!			cons(1)=cons(1)+ConB(1,history(1),transhis(1))+aut
!			varlnconage(1)=varlnconage(1)+(log(ConB(1,history(1),transhis(1))+aut)-avlnconage(1))**2
!			avdoid=avdoid+((bmax+1-kpos(1))/gridfine)/wage
!			baddebt=baddebt+(bmax+1-kpos(1))/gridfine
!			outdef=outdef+wage
!			increason=1		!	No income shock	!
!			transreason=1		!	No income shock	!
!			BRbyreason(shockhis(age),increason,transreason)=BRbyreason(shockhis(age),increason,transreason)+1.0
!			if (Vbaralt(1,history(1),transhis(1))>VbarFS(1,history(1),transhis(1))) then
!				wannasave=wannasave+1.0
!			endif
!			kprime=bmax+1
!		else
			stigma(1)=0
			kprime=BR(1,history(1),transhis(1),kpos(1))
			cons(1)=cons(1)+Con(1,history(1),transhis(1),kpos(1))+aut
			varlnconage(1)=varlnconage(1)+(log(Con(1,history(1),transhis(1),kpos(1))+aut)-avlnconage(1))**2
!		end if

		if (kprime<bmax+1) then
			debtadd=-(q(1,history(1),kprime)*(kprime-1-bmax)/gridfine)
			if (debtadd<0) then
				print *,'Debt<0'
				print *,'q=',q(1,history(1),kprime)
				!pause
			else
				debt=debt+debtadd
				debtB(bin)=debtB(bin)+debtadd
				borrowB(bin)=borrowB(bin)+1.0
				debtbyage(1)=debtbyage(1)+debtadd
				borrowante=borrowante+1.0
				borrow(1,history(1),transhis(1),shockhis(1))=borrow(1,history(1),transhis(1),shockhis(1)) + 1.0
				avborint=avborint-(1-q(1,history(1),kprime))*(kprime-bmax-1)/gridfine
			end if
		else
			debtadd=((kprime-1-bmax)/gridfine)/(1+rs)
			saving=saving+debtadd
			savebyage(1)=savebyage(1)+debtadd
		end if


		do age=2,lifespan-1
			wss=ran(iii)
			!	Assigning Markov productivity	!
			sstop=0
			asum=0.0
			s=1
			do while (sstop.eq.0)
				if (wss < asum + prob(history(age-1),s)) then
					history(age)=s
					sstop=1
					if (s>states) then
						print *,'Run #',j,' Person #',i,' Age =',age,' Markov =',s,' Random =',wss
						history(age)=states
					end if
				else
					asum = asum + prob(history(age-1),s)
					s=s+1
				end if
			end do

			wss=ran(iii)
			!	Assigning transitory productivity	!
			sstop=0
			asum=0.0
			st=1
			do while (sstop.eq.0)
				if (wss < asum + probt(st)) then
					transhis(age)=st
					sstop=1
					if (st>trans) then
						print *,'Run #',j,' Person #',i,' Age =',age,' Transitory =',st,' Random =',wss
						transhis(age)=trans
					end if
				else
					asum = asum + probt(st)
					st=st+1
				end if
			end do

			wss=ran(iii)
			!	Assigning expense shock	!
			sstop=0
			asum=0.0
			sh=1
			do while (sstop.eq.0)
				if (wss < asum + probs(sh)) then
					shockhis(age)=sh
					sstop=1
					if (sh>shocks+1) then
						print *,'Run #',j,' Person #',i,' Age =',age,' Expense =',sh,' Random =',wss
						shockhis(age)=shocks+1
					end if
				else
					asum = asum + probs(sh)
					sh=sh+1
				end if
			end do

			wage=phi(history(age))*A(transhis(age))*hbar(age)
			bin=bins(age,history(age),transhis(age))
			PopB(bin)=PopB(bin)+1
			outputB(bin)=outputB(bin)+wage

			ystig1=(stigma(age-1).eq.1)
			ystig2=(stigma(age-1).eq.2)
			ystig3=(stigma(age-1).eq.3)
			if (ystig1) then
				kpos(age)=bmax+1
			else if (ystig2) then
				kpos(age)=BRafter(age-1,history(age-1),transhis(age-1),shockhis(age-1))
			else if (ystig3) then
				kpos(age)=DebtRolled(age-1,history(age-1),transhis(age-1),shockhis(age-1))
			else
				kpos(age)=BR(age-1,history(age-1),transhis(age-1),kpos(age-1))
			end if
			loss=nint(expense(history(age),shockhis(age))*gridfine)
			kpos(age)=max(kpos(age)-loss,1)
			if (kpos(age) < bmax+1) then
				borrowers=borrowers+1.0
				avdoib=avdoib+((bmax+1-kpos(age))/gridfine)/wage
				borpostB(bin)=borpostB(bin)+1.0
				avdebincB(bin)=avdebincB(bin)+((bmax+1-kpos(age))/gridfine)/wage
				debtpostB(bin)=debtpostB(bin)+(bmax+1-kpos(age))/gridfine
			end if

			if (wage>0.0) then
				output=output+wage
				varlnincage(age)=varlnincage(age)+(log(wage)-avlnincage(age))**2
			else
				varlnincage(age)=varlnincage(age)+(-1.0d80-avlnincage(age))**2
			end if

			run0=(V(age,history(age),transhis(age),kpos(age))<VbarFS(age,history(age),transhis(age)))
			defafter=(Vafter(age,history(age),transhis(age),shockhis(age))<Vdef(age,history(age),transhis(age),shockhis(age)))


			if (ystig1) then
				if (defafter) then
					defaults=defaults+1.0
					stigma(age)=3
					kprime=bmax+1		!	Rolled-over debts do not get counted
!					kprime=DebtRolled(age,history(age),transhis(age),shockhis(age))
					cons(age)=cons(age)+ConD(age,history(age),transhis(age),shockhis(age))+aut
					varlnconage(age)=varlnconage(age)+(log(ConD(age,history(age),transhis(age),shockhis(age))+aut)-avlnconage(age))**2
				else
					stigma(age)=2
					kprime=BRafter(age,history(age),transhis(age),shockhis(age))
					cons(age)=cons(age)+Con1(age,history(age),transhis(age),shockhis(age))+aut
					varlnconage(age)=varlnconage(age)+(log(Con1(age,history(age),transhis(age),shockhis(age))+aut)-avlnconage(age))**2
				end if
			else if (run0) then
				bankruptcy=bankruptcy+1.0
				newbankruptcy(age)=newbankruptcy(age)+1.0
				filingsB(bin)=filingsB(bin)+1.0
				stigma(age)=1
				cons(age)=cons(age)+ConB(age,history(age),transhis(age))+aut
				varlnconage(age)=varlnconage(age)+(log(ConB(age,history(age),transhis(age))+aut)-avlnconage(age))**2
				avdoid=avdoid+((bmax+1-kpos(age))/gridfine)/wage
				baddebt=baddebt+(bmax+1-kpos(age))/gridfine
				outdef=outdef+wage
				if (history(age)<history(age-1)) then
					increason=2		!	Persistent income shock	!
				else
					increason=1		!	No income shock	!
				endif
				if (transhis(age)<avtrans) then
					transreason=2		!	Transitory income shock	!
				else
					transreason=1		!	No income shock	!
				endif
				if (Vbaralt(age,history(age),transhis(age))>VbarFS(age,history(age),transhis(age))) then
					wannasave=wannasave+1.0
				endif

				BRbyreason(shockhis(age),increason,transreason)=BRbyreason(shockhis(age),increason,transreason)+1.0
				kprime=bmax+1
			else
				stigma(age)=0
				kprime=BR(age,history(age),transhis(age),kpos(age))
				cons(age)=cons(age)+Con(age,history(age),transhis(age),kpos(age))+aut
				varlnconage(age)=varlnconage(age)+(log(Con(age,history(age),transhis(age),kpos(age))+aut)-avlnconage(age))**2
			end if

			if (kprime<bmax+1) then
				debtadd=-(q(age,history(age),kprime)*(kprime-1-bmax)/gridfine)
				if (debtadd<0) then
					print *,'Debt<0'
					do kk=1,age
						print *,history(kk), transhis(kk), shockhis(kk)
					end do
					print *,'q=',q(age,history(age),kprime)
					!pause
				else
					debt=debt+debtadd
					debtB(bin)=debtB(bin)+debtadd
					borrowB(bin)=borrowB(bin)+1.0
					debtbyage(age)=debtbyage(age)+debtadd
!					debtdist(age,history(age),transhis(age),shockhis(age))=debtdist(age,history(age),transhis(age),shockhis(age))+debtadd
					borrowante=borrowante+1.0
					borrow(age,history(age),transhis(age),shockhis(age))=borrow(age,history(age),transhis(age),shockhis(age)) + 1.0
					avborint=avborint-(1-q(age,history(age),kprime))*(kprime-bmax-1)/gridfine
				end if
			else
				debtadd=((kprime-1-bmax)/gridfine)/(1+rs)
				saving=saving+debtadd
				savebyage(age)=savebyage(age)+debtadd
			end if

		end do


		age=lifespan
		history(age)=history(age-1)
		transhis(age)=avtrans
		shockhis(age)=shocks+1
		wage=phi(history(age))*hbar(age)

		ystig1=(stigma(age-1).eq.1)
		ystig2=(stigma(age-1).eq.2)
		ystig3=(stigma(age-1).eq.3)
		if (ystig1) then
			kpos(age)=bmax+1
		else if (ystig2) then
			kpos(age)=BRafter(age-1,history(age-1),transhis(age-1),shockhis(age-1))
		else if (ystig3) then
			kpos(age)=DebtRolled(age-1,history(age-1),transhis(age-1),shockhis(age-1))
		else
			kpos(age)=BR(age-1,history(age-1),transhis(age-1),kpos(age-1))
		end if
		if (kpos(age) < bmax+1) then
			borrowers=borrowers+1.0
			avdoib=avdoib+((bmax+1-kpos(age))/gridfine)/wage
		end if

		if (wage>0.0) then
			output=output+wage
			varlnincage(age)=varlnincage(age)+(log(wage)-avlnincage(age))**2
		else
			varlnincage(age)=varlnincage(age)+(-1.0d80-avlnincage(age))**2
		end if

		!	Note:	The only bankruptcies here are last periods' defaults		!
		if (ystig3) then
			bankruptcy=bankruptcy+1.0
			newbankruptcy(age)=newbankruptcy(age)+1.0
			cons(age)=cons(age)+ConB(age,history(age),transhis(age))+autlast
			avdoid=avdoid+((bmax+1-kpos(age))/gridfine)/wage
			baddebt=baddebt+(bmax+1-kpos(age))/gridfine
			varlnconage(age)=varlnconage(age)+(log(ConB(age,history(age),transhis(age))+autlast)-avlnconage(age))**2
			outdef=outdef+wage
			increason=1		!	No income shock	!
			transreason=1		!	No income shock	!
			BRbyreason(shockhis(age),increason,transreason)=BRbyreason(shockhis(age),increason,transreason)+1.0
		else if (ystig1) then
			cons(age)=cons(age)+Con1(age,history(age),transhis(age),shockhis(age))+autlast
			varlnconage(age)=varlnconage(age)+(log(Con1(age,history(age),transhis(age),shockhis(age))+autlast)-avlnconage(age))**2
		else
			cons(age)=cons(age)+Con(age,history(age),transhis(age),kpos(age))+autlast
			varlnconage(age)=varlnconage(age)+(log(Con(age,history(age),transhis(age),kpos(age))+autlast)-avlnconage(age))**2
		endif

	end do

	bankrtotal(j)=(bankruptcy/Pop)/lifespan
	defaulttotal(j)=(defaults/Pop)/lifespan
	if (debt>0.0) then
		avinttotal(j)=avborint/debt
		debttotal(j)=(debt/Pop)/lifespan
		borrowerantetotal(j)=(borrowante/Pop)/lifespan
	else
		avinttotal(j)=0.0
		debttotal(j)=0.0
		borrowerantetotal(j)=0.0
	end if
	savetotal(j)=(saving/Pop)/lifespan
	if (borrowers>0.0) then
		borrowerposttotal(j)=(borrowers/Pop)/lifespan
		debtincbortotal(j)=avdoib/borrowers
	else
		borrowerposttotal(j)=0.0
		debtincbortotal(j)=0.0
	end if
	if (bankruptcy>0.0) then
		debtincdeftotal(j)=avdoid/bankruptcy
		writeoff(j)=baddebt/bankruptcy
		savers(j)=wannasave/bankruptcy
	else
		debtincdeftotal(j)=0.0
		writeoff(j)=0.0
		savers(j)=0.0
	end if

end do

varlnconage = (varlnconage/Pop)/(Monte-Monte1)
varlnincage = (varlnincage/Pop)/(Monte-Monte1)
varlncon=0.0
varlninc=0.0
do age=1,lifespan
	varlncon = varlncon + varlnconage(age)
	varlninc = varlninc + varlnincage(age)
end do
varlncon = varlncon/lifespan
varlninc = varlninc/lifespan



994 format (I4,9F9.5)
open (18,file='MonteOut.txt')
write (18,*) 'Input ID#',id
write (18,*) Monte,'experiments with',Pop,'people in each generation'
write (18,*) 'Run Bankruptcies AvInterest Debt Savings ExAnteBorrowers ExPostBorrowers (Debt/Income)Borrowers (Debt/Income)Bankrupts BadDebt'
do i=1,Monte
	write (18,994) i, bankrtotal(i), avinttotal(i), debttotal(i), savetotal(i), borrowerantetotal(i), borrowerposttotal(i), debtincbortotal(i), debtincdeftotal(i), writeoff(i)
end do
close (18)


debt=0.0
saving=0.0
bankruptcy=0.0
wannasave=0.0
defaults=0.0
avborint=0.0
borrowante=0.0
borrowers=0.0
avdoid=0.0
avdoib=0.0
baddebt=0.0
do i=1,Monte
	debt=debt+debttotal(i)
	saving=saving+savetotal(i)
	avborint=avborint+avinttotal(i)*debttotal(i)
	bankruptcy=bankruptcy+bankrtotal(i)
	defaults=defaults+defaulttotal(i)
	borrowante=borrowante+borrowerantetotal(i)
	borrowers=borrowers+borrowerposttotal(i)
	avdoid=avdoid+debtincdeftotal(i)*bankrtotal(i)
	baddebt=baddebt+writeoff(i)*bankrtotal(i)
	wannasave=wannasave+savers(i)*bankrtotal(i)
	avdoib=avdoib+debtincbortotal(i)*borrowerposttotal(i)
end do
avborint=avborint/debt		!	Debt-weighted across simulations!

debt=debt/Monte
saving=saving/Monte
bankruptcy=bankruptcy/Monte
defaults=defaults/Monte
borrowante=borrowante/Monte
borrowers=borrowers/Monte


cons=(cons/Pop)/Monte
debtbyage=(debtbyage/Pop)/Monte
savebyage=(savebyage/Pop)/Monte
newbankruptcy=(newbankruptcy/Pop)/Monte
BRbyreason=(BRbyreason/Pop)/(Monte*lifespan)

output=(output/Pop)/(Monte*lifespan)
if (bankruptcy>0) then
	outdef = (outdef/Pop)/(bankruptcy*Monte*lifespan)
	avdoid = avdoid/(bankruptcy*Monte)
	baddebt = baddebt/(bankruptcy*Monte)
	wannasave = wannasave/(bankruptcy*Monte)
end if
if (borrowers>0) then
	avdoib = avdoib/(borrowers*Monte)
end if

do age=1,(lifespan-1)
	do s=1,states
		do st=1,trans
			do sh=1,shocks+1
				if (borrow(age,s,st,sh)>0.0) then
					borrowbyage(age)=borrowbyage(age)+borrow(age,s,st,sh)
					asum=prob0(s)*probt(st)*probs(sh)*Pop*Monte
					fracborrow(age,s,st,sh)=borrow(age,s,st,sh)/asum
				end if
			end do
		end do
	end do
	borrowbyage(age)=(borrowbyage(age)/Pop)/Monte
end do

do i=1,groups
	debincB(i)=debtB(i)/outputB(i)
	outputB(i)=outputB(i)/PopB(i)
	debtB(i)=debtB(i)/PopB(i)
	borrowB(i)=borrowB(i)/PopB(i)
	avdebincB(i)=avdebincB(i)/borpostB(i)
	debtpostB(i)=debtpostB(i)/PopB(i)
	borpostB(i)=borpostB(i)/PopB(i)
	filingsB(i)=filingsB(i)/PopB(i)
end do




open (20,file='outputlong.txt')
write (20,*) 'Input ID#',id
write (20,*) 'Exemption, Garnishment, Burnt:', cbar,garn,burn
write (20,*) 'Autonomous, Saving rate, Risk-free borrowing rate, Ceiling, Roll-over rate:', aut,rs,rb,rmax,rroll
write (20,*) 'Expense shocks intercepts:',expenconst
write (20,*) 'Expense shocks slopes:',expenprop
write (20,*) 'Results:'
write (20,*) 'EV=',EV
write (20,*) 'Fraction declaring bankruptcy',bankruptcy
write (20,*) 'Fraction in default (after bankruptcy)',defaults
write (20,*) 'Total earnings =',output
write (20,*) 'Debt=',debt
write (20,*) 'Debt/Earnings=',debt/output
write (20,*) 'Savings=',saving
write (20,*) 'Savings/Earnings=',saving/output
write (20,*) 'Median earnings is ', R_valmed(earnings)
write (20,*) 'Median (total) income is ', R_valmed(income)
write (20,*) 'Median wealth is ', R_valmed(wealth)
write (20,*) 'Fraction of bankrupts who want to save',wannasave
write (20,*) 'Fraction of ex-post borrowers = ',borrowers
write (20,*) 'Fraction of ex-ante borrowers = ',borrowante
if (bankruptcy>0) then
	write (20,*) 'Mean Gross Earnings of Defaulters=',outdef
	write (20,*) 'BankruptY / AverageY =',outdef/output
	write (20,*) 'Average (ex-post) debt/income of bankrupts:',avdoid
	write (20,*) 'Ex-post debt of bankrupts:',baddebt
	write (20,*) 'Av(ex-post)debt/Av.income of bankrupts:',baddebt/outdef
end if
write (20,*) 'Average (ex-post) debt/income of borrowers:',avdoib
write (20,*) 'Average borrowing interest rate:',avborint
write (20,*) 'Variance of log Consumption (incl. autonomous):',varlncon
write (20,*) 'Variance of log Income:',varlninc

write (20,*) 'New Bankruptcies by age:',newbankruptcy
write (20,*) 'Debt (ex-ante) by age:',debtbyage
write (20,*) 'Savings (before interest) by age:',savebyage
write (20,*) 'Fraction of borrowers (ex-ante) by age:',borrowbyage
write (20,*) 'Average Consumption (incl. autonomous) by age:',cons
write (20,*) 'Variance of log Consumption (incl. autonomous) by age:',varlnconage
write (20,*) 'Variance of log Income by age:',varlnincage

write (20,*) 'Bankruptcies by reason:'
write (20,*) 'No bad Markov shock, No bad transitory shock:',BRbyreason(1:(shocks+1),1,1)
write (20,*) 'Bad Markov shock, No bad transitory shock:',BRbyreason(1:(shocks+1),2,1)
write (20,*) 'No bad Markov shock, Bad transitory shock:',BRbyreason(1:(shocks+1),1,2)
write (20,*) 'Bad Markov shock, Bad transitory shock:',BRbyreason(1:(shocks+1),2,2)
close (20)

997 format (I2,16F6.4)
open (19,file='borrowersFS.txt')
write (19,*) 'Input ID#',id
write (19,*) 'Fraction of (ex-ante, voluntary) borrowers among specific groups:'
write (19,*) 'Groups are listed by expense shock (starting with no shock), then by transitory income'
write (19,*) 'For each group, the table has rows corresponding to persistent state and columns corresponding to age'
sh=shocks+1
	write (19,*) 'No expense shock'
	do st=1,trans
		write (19,*) '	Transitory state',st
		write (19,*) 'Persistent_state','Fractions_of_borrowers_by_age'
		do s=1,states
			write (19,997) s, fracborrow(1:16,s,st,sh)
		end do
	end do
do sh=1,shocks
	write (19,*) 'Expense shock',sh
	do st=1,trans
		write (19,*) '	Transitory state',st
		write (19,*) 'Persistent_state','Fractions_of_borrowers_by_age'
		do s=1,states
			write (19,997) s, fracborrow(1:16,s,st,sh)
		end do
	end do
end do
close (19)


993 format (I4,9F9.5)
open (23,file='BinsOut.txt')
write (23,*) 'Input ID#',id
write (23,*) ' Bin Income (Ex-ante)Debt (Ex-ante)Borrowers (Ex-ante)Debt/Income (Ex-post)Debt (Ex-post)Borrowers (Ex-post)Debt/Income Av(Ex-post)Debt/Income_of_borrowers FractionFiling'
do i=1,groups
	write (23,993) i, outputB(i), debtB(i), borrowB(i), debincB(i), debtpostB(i), borpostB(i), (debtpostB(i)/outputB(i)), avdebincB(i), filingsB(i)
end do
close (23)



print *,'Fraction declaring bankruptcy',bankruptcy
print *,'Fraction in default (after bankruptcy)',defaults
print *,'New Bankruptcies:',newbankruptcy
print *,'Debt=',debt
print *,'Earnings=',output
print *,'Debt/Earnings=',debt/output
print *,'Savings=',saving
print *,'Savings/Earnings=',saving/output
print *,'Fraction of ex-post borrowers = ',borrowers
print *,'Fraction of ex-ante borrowers = ',borrowante
if (bankruptcy>0.0) then
	print *,'Mean Gross Earnings of Defaulters=',outdef
	print *,'BankruptY / AverageY =',outdef/output
	print *,'Average (ex-post) debt/income of bankrupts =',avdoid
	print *,'Ex-post debt of bankrupts:',baddebt
	print *,'Av(ex-post)debt/Av.income of bankrupts:',baddebt/outdef
end if
print *,'Average (ex-post) debt/income of borrowers =',avdoib
print *,'EV=',EV

!pause
777 end program



Real(8) Function Utility(c,cig)
real(8) c, cig
Utility=c**(1-cig)/(1-cig)
end function


Function Sort(unsorted) !Result (sorted)
Real, Dimension (:) :: unsorted
Real, Dimension (size(unsorted)) :: Sort, sorted
!Real unsorted(1024), sorted(1024), wss
Real wss
Integer i, ii, k, sstop, limitn
limitn=size(unsorted)
sorted(1)=unsorted(1)
do i=2,limitn
	wss=unsorted(i)
	sstop=0
	ii=1
	do while (sstop.eq.0)
		if (wss < sorted(ii)) then
			do k=i,(ii+1),-1
				sorted(k)=sorted(k-1)
			end do
			sorted(ii)=wss
			sstop=1
		elseif (ii.eq.(i-1)) then
			sorted(i)=wss
			sstop=1
		else
			ii=ii+1
		end if
	end do
end do
Sort=sorted
end function

Recursive Function R_valmed (XDONT) Result (res_med)
!  Finds the median of XDONT using the recursive procedure
!  described in Knuth, The Art of Computer Programming,
!  vol. 3, 5.3.3 - This procedure is linear in time, and
!  does not require to be able to interpolate in the
!  set as the one used in INDNTH. It also has better worst
!  case behavior than INDNTH, but is about 30% slower in
!  average for random uniformly distributed values.
! __________________________________________________________
! _________________________________________________________
      Real, Dimension (:), Intent (In) :: XDONT
      Real :: res_med
! __________________________________________________________
      Real, Parameter :: XHUGE = HUGE (XDONT)
      Real, Dimension (SIZE(XDONT)+6) :: XWRKT
      Real :: XWRK, XWRK1, XMED7
!
	      Integer, Dimension ((SIZE(XDONT)+6)/7) :: ISTRT, IENDT, IMEDT
      Integer :: NDON, NTRI, NMED, NORD, NEQU, NLEQ, IMED, IDON, IDON1
      Integer :: IDEB, IWRK, IDCR, ICRS, ICRS1, ICRS2, IMED1
!
      NDON = SIZE (XDONT)
      NMED = (NDON+1) / 2
!      write(unit=*,fmt=*) NMED, NDON
!
!  If the number of values is small, then use insertion sort
!
      If (NDON < 35) Then
!
!  Bring minimum to first location to save test in decreasing loop
!
         IDCR = NDON
         If (XDONT (1) < XDONT (NDON)) Then
            XWRK = XDONT (1)
            XWRKT (IDCR) = XDONT (IDCR)
         Else
            XWRK = XDONT (IDCR)
            XWRKT (IDCR) = XDONT (1)
         Endif
         Do IWRK = 1, NDON - 2
            IDCR = IDCR - 1
            XWRK1 = XDONT (IDCR)
            If (XWRK1 < XWRK) Then
                XWRKT (IDCR) = XWRK
                XWRK = XWRK1
            Else
                XWRKT (IDCR) = XWRK1
            Endif
         End Do
         XWRKT (1) = XWRK
!
! Sort the first half, until we have NMED sorted values
!
         Do ICRS = 3, NMED
            XWRK = XWRKT (ICRS)
               IDCR = ICRS - 1
               Do
                  If (XWRK >= XWRKT(IDCR)) Exit
                  XWRKT (IDCR+1) = XWRKT (IDCR)
                  IDCR = IDCR - 1
               End Do
            XWRKT (IDCR+1) = XWRK
         End Do
!
!  Insert any value less than the current median in the first half
!
         Do ICRS = NMED+1, NDON
            XWRK = XWRKT (ICRS)
            If (XWRK < XWRKT (NMED)) Then
               IDCR = NMED - 1
               Do
                  If (XWRK >= XWRKT(IDCR)) Exit
                  XWRKT (IDCR+1) = XWRKT (IDCR)
                  IDCR = IDCR - 1
               End Do
               XWRKT (IDCR+1) = XWRK
            End If
         End Do
         res_med = XWRKT (NMED)
         Return
      End If
!
!
!  Make sorted subsets of 7 elements
!  This is done by a variant of insertion sort where a first
!  pass is used to bring the smallest element to the first position
!  decreasing disorder at the same time, so that we may remove
!  remove the loop test in the insertion loop.
!
      DO IDEB = 1, NDON-6, 7
         IDCR = IDEB + 6
         If (XDONT (IDEB) < XDONT (IDCR)) Then
            XWRK = XDONT (IDEB)
            XWRKT (IDCR) = XDONT (IDCR)
         Else
            XWRK = XDONT (IDCR)
            XWRKT (IDCR) = XDONT (IDEB)
         Endif
         Do IWRK = 1, 5
            IDCR = IDCR - 1
            XWRK1 = XDONT (IDCR)
            If (XWRK1 < XWRK) Then
                XWRKT (IDCR) = XWRK
                XWRK = XWRK1
            Else
                XWRKT (IDCR) = XWRK1
            Endif
         End Do
         XWRKT (IDEB) = XWRK
         Do ICRS = IDEB+2, IDEB+6
            XWRK = XWRKT (ICRS)
            If (XWRK < XWRKT(ICRS-1)) Then
               XWRKT (ICRS) = XWRKT (ICRS-1)
               IDCR = ICRS - 1
               XWRK1 = XWRKT (IDCR-1)
               Do
                  If (XWRK >= XWRK1) Exit
                  XWRKT (IDCR) = XWRK1
                  IDCR = IDCR - 1
                  XWRK1 = XWRKT (IDCR-1)
               End Do
               XWRKT (IDCR) = XWRK
            EndIf
         End Do
      End Do
!
!  Add-up alternatively + and - HUGE values to make the number of data
!  an exact multiple of 7.
!
      IDEB = 7 * (NDON/7)
      NTRI = NDON
      If (IDEB < NDON) Then
!
         XWRK1 = XHUGE
         Do ICRS = IDEB+1, IDEB+7
            If (ICRS <= NDON) Then
               XWRKT (ICRS) = XDONT (ICRS)
            Else
               If (XWRK1 /= XHUGE) NMED = NMED + 1
               XWRKT (ICRS) = XWRK1
               XWRK1 = - XWRK1
            Endif
         End Do
!
         Do ICRS = IDEB+2, IDEB+7
            XWRK = XWRKT (ICRS)
            Do IDCR = ICRS - 1, IDEB+1, - 1
               If (XWRK >= XWRKT(IDCR)) Exit
               XWRKT (IDCR+1) = XWRKT (IDCR)
            End Do
            XWRKT (IDCR+1) = XWRK
         End Do
!
         NTRI = IDEB+7
      End If
!
!  Make the set of the indices of median values of each sorted subset
!
         IDON1 = 0
         Do IDON = 1, NTRI, 7
            IDON1 = IDON1 + 1
            IMEDT (IDON1) = IDON + 3
         End Do
!
!  Find XMED7, the median of the medians
!
         XMED7 = R_valmed (XWRKT (IMEDT))
!
!  Count how many values are not higher than (and how many equal to) XMED7
!  This number is at least 4 * 1/2 * (N/7) : 4 values in each of the
!  subsets where the median is lower than the median of medians. For similar
!  reasons, we also have at least 2N/7 values not lower than XMED7. At the
!  same time, we find in each subset the index of the last value < XMED7,
!  and that of the first > XMED7. These indices will be used to restrict the
!  search for the median as the Kth element in the subset (> or <) where
!  we know it to be.
!
         IDON1 = 1
         NLEQ = 0
         NEQU = 0
         Do IDON = 1, NTRI, 7
            IMED = IDON+3
            If (XWRKT (IMED) > XMED7) Then
                  IMED = IMED - 2
                  If (XWRKT (IMED) > XMED7) Then
                     IMED = IMED - 1
                  Else If (XWRKT (IMED) < XMED7) Then
                     IMED = IMED + 1
                  Endif
            Else If (XWRKT (IMED) < XMED7) Then
                  IMED = IMED + 2
                  If (XWRKT (IMED) > XMED7) Then
                     IMED = IMED - 1
                  Else If (XWRKT (IMED) < XMED7) Then
                     IMED = IMED + 1
                  Endif
            Endif
            If (XWRKT (IMED) > XMED7) Then
               NLEQ = NLEQ + IMED - IDON
               IENDT (IDON1) = IMED - 1
               ISTRT (IDON1) = IMED
            Else If (XWRKT (IMED) < XMED7) Then
               NLEQ = NLEQ + IMED - IDON + 1
               IENDT (IDON1) = IMED
               ISTRT (IDON1) = IMED + 1
            Else                    !       If (XWRKT (IMED) == XMED7)
               NLEQ = NLEQ + IMED - IDON + 1
               NEQU = NEQU + 1
               IENDT (IDON1) = IMED - 1
               Do IMED1 = IMED - 1, IDON, -1
                  If (XWRKT (IMED1) == XMED7) Then
                     NEQU = NEQU + 1
                     IENDT (IDON1) = IMED1 - 1
                  Else
                     Exit
                  End If
               End Do
               ISTRT (IDON1) = IMED + 1
               Do IMED1 = IMED + 1, IDON + 6
                  If (XWRKT (IMED1) == XMED7) Then
                     NEQU = NEQU + 1
                     NLEQ = NLEQ + 1
                     ISTRT (IDON1) = IMED1 + 1
                  Else
                     Exit
                  End If
               End Do
            Endif
            IDON1 = IDON1 + 1
         End Do
!
!  Carry out a partial insertion sort to find the Kth smallest of the
!  large values, or the Kth largest of the small values, according to
!  what is needed.
!
        If (NLEQ - NEQU + 1 <= NMED) Then
            If (NLEQ < NMED) Then   !      Not enough low values
                XWRK1 = XHUGE
                NORD = NMED - NLEQ
                IDON1 = 0
                ICRS1 = 1
                ICRS2 = 0
                IDCR = 0
               Do IDON = 1, NTRI, 7
                   IDON1 = IDON1 + 1
                   If (ICRS2 < NORD) Then
                      Do ICRS = ISTRT (IDON1), IDON + 6
                         If (XWRKT(ICRS) < XWRK1) Then
                            XWRK = XWRKT (ICRS)
                            Do IDCR = ICRS1 - 1, 1, - 1
                               If (XWRK >= XWRKT(IDCR)) Exit
                               XWRKT (IDCR+1) = XWRKT (IDCR)
                            End Do
                            XWRKT (IDCR+1) = XWRK
                            XWRK1 = XWRKT(ICRS1)
                         Else
                           If (ICRS2 < NORD) Then
                              XWRKT (ICRS1) = XWRKT (ICRS)
                              XWRK1 = XWRKT(ICRS1)
                           Endif
                         End If
                         ICRS1 = MIN (NORD, ICRS1 + 1)
                         ICRS2 = MIN (NORD, ICRS2 + 1)
                      End Do
                   Else
                      Do ICRS = ISTRT (IDON1), IDON + 6
                         If (XWRKT(ICRS) >= XWRK1) Exit
                         XWRK = XWRKT (ICRS)
                         Do IDCR = ICRS1 - 1, 1, - 1
                               If (XWRK >= XWRKT(IDCR)) Exit
                               XWRKT (IDCR+1) = XWRKT (IDCR)
                         End Do
                         XWRKT (IDCR+1) = XWRK
                         XWRK1 = XWRKT(ICRS1)
                      End Do
                   End If
                End Do
                res_med = XWRK1
                Return
            Else
                res_med = XMED7
                Return
            End If
         Else                       !      If (NLEQ > NMED)
!                                          Not enough high values
                XWRK1 = -XHUGE
                NORD = NLEQ - NEQU - NMED + 1
                IDON1 = 0
                ICRS1 = 1
                ICRS2 = 0
                Do IDON = 1, NTRI, 7
                   IDON1 = IDON1 + 1
                   If (ICRS2 < NORD) Then
!
                      Do ICRS = IDON, IENDT (IDON1)
                         If (XWRKT(ICRS) > XWRK1) Then
                            XWRK = XWRKT (ICRS)
                            IDCR = ICRS1 - 1
                            Do IDCR = ICRS1 - 1, 1, - 1
                               If (XWRK <= XWRKT(IDCR)) Exit
                               XWRKT (IDCR+1) = XWRKT (IDCR)
                            End Do
                            XWRKT (IDCR+1) = XWRK
                            XWRK1 = XWRKT(ICRS1)
                         Else
                            If (ICRS2 < NORD) Then
                               XWRKT (ICRS1) = XWRKT (ICRS)
                               XWRK1 = XWRKT (ICRS1)
                            End If
                         End If
                         ICRS1 = MIN (NORD, ICRS1 + 1)
                         ICRS2 = MIN (NORD, ICRS2 + 1)
                      End Do
                   Else
                      Do ICRS = IENDT (IDON1), IDON, -1
                         If (XWRKT(ICRS) > XWRK1) Then
                            XWRK = XWRKT (ICRS)
                            IDCR = ICRS1 - 1
                            Do IDCR = ICRS1 - 1, 1, - 1
                               If (XWRK <= XWRKT(IDCR)) Exit
                               XWRKT (IDCR+1) = XWRKT (IDCR)
                            End Do
                            XWRKT (IDCR+1) = XWRK
                            XWRK1 = XWRKT(ICRS1)
                         Else
                            Exit
                         End If
                      End Do
                   Endif
                End Do
!
                res_med = XWRK1
                Return
         End If
!
End Function R_valmed




